#include "sonnenposition.h"

JDatum Datum2JDatum(Zeit Jetzt){
 double Stunden;
 int8_t A, Jahrhunderte;
 uint16_t C;
 uint32_t B;
 JDatum Jdatum;

 if (Jetzt.Monat<=2){
  Jetzt.Jahr-=1;
  Jetzt.Monat+=12;
 }; 

 Stunden=(double) Jetzt.Stunden/24 + (double) Jetzt.Minuten/1440;
 Jahrhunderte=(Jetzt.Jahr/100);
 A=2-Jahrhunderte+Jahrhunderte/4;
 B=365.25*(Jetzt.Jahr+4716);
 C=(30.6001*(Jetzt.Monat+1));
 Jdatum.jd0=(A + B + C + Jetzt.Tag - 1524.5);
 Jdatum.jd=(A + B + C + Jetzt.Tag + Stunden - 1524.5);
 Jdatum.T0=(Jdatum.jd0-2451545.0)/36525.0;
 Jdatum.T=Stunden*24;
 return Jdatum;
}

Koordinaten Positionsbestimmung(JDatum Jdatum, Standort Ort){
 double n,L,g,A;
 double Deklination, Ekliptik, Nenner, Nenner2, Rektaszension;
 double StundenwinkelFP, GStundenwinkelFP, OStundenwinkelFP, OStundenwinkel;
 Koordinaten Position;

 n=Jdatum.jd-2451545.0;
 L=fmod(280.46+0.9856474*n,360);
 g=fmod(357.528+0.9856003*n,360);
 A=L+(e*360/M_PI)*sin(g*M_PI/180)+(225*e*e/M_PI)*sin(2*g*M_PI/180);
 Ekliptik=23.439+0.0000004*n;
 Nenner=cos(A*M_PI/180);
 Rektaszension=atan((cos(Ekliptik*M_PI/180)*sin(A*M_PI/180))/Nenner)*180/M_PI;
 if (Nenner<0) Rektaszension+=180;
 Deklination=asin(sin(Ekliptik*M_PI/180)*sin(A*M_PI/180))*180/M_PI;
 StundenwinkelFP=fmod(6.697376+(2400.05134*Jdatum.T0)+(1.002738*Jdatum.T),24);
 GStundenwinkelFP=StundenwinkelFP*15;
 OStundenwinkelFP=GStundenwinkelFP+Ort.Breite;
 OStundenwinkel=OStundenwinkelFP-Rektaszension;
 Nenner2=cos(OStundenwinkel*M_PI/180)*sin(Ort.Laenge*M_PI/180)-tan(Deklination*M_PI/180)*cos(Ort.Laenge*M_PI/180);
 Position.Azimut=atan(sin(OStundenwinkel*M_PI/180)/Nenner2)*180/M_PI;
 if (Nenner2<0) Position.Azimut+=180;
 Position.Azimut=360-Position.Azimut;
 Position.Hoehenwinkel=asin(cos(Deklination*M_PI/180)*cos(OStundenwinkel*M_PI/180)*cos(Ort.Laenge*M_PI/180)+sin(Deklination*M_PI/180)*sin(Ort.Laenge*M_PI/180))*180/M_PI;
 
 return Position;
}
